const BattleCalc = require('../../BattleCalc')

const AStarTileGrid = function( tiles ) {
	this.allNodes = tiles;

	for( var i = 0; i < this.allNodes.length; ++i ) {
		this.allNodes[i].isTraversable = function() {
			return !this.occupied;
		};
	}

	this.getNodeAtCoords = function( x, y ) {
		for( var i = 0; i < this.allNodes.length; ++i ) {
			var tile = this.allNodes[ i ];
			if( tile.x===x && tile.y===y ) {
				return tile;
			}
		}
		return null;
	};
	
	this.getAdjacentNodes = ( subject ) => {
		var adjacentTiles = [];
		
		for( var i = 0; i < this.allNodes.length; ++i ) {
			var tile = this.allNodes[ i ];
			if( BattleCalc.adjacent(subject,tile) ) {
				adjacentTiles.push( tile );
			}
		}
		
		return adjacentTiles;
	};
	
	this.nodesAreAdjacent = ( a, b ) => {
		return BattleCalc.adjacent( a, b );
	};
	
	this.heuristic = ( startNode, endNode ) => {
		return BattleCalc.boardDistance( startNode, endNode );
	}
}
module.exports = AStarTileGrid
