/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const YesNoNode = require( '../YesNoNode' );
const BattleCalc = require( '../../BattleCalc' );
const TreeNode = require( '../TreeNode' );
const UseAbility = require( '../UseAbility' );

const Q_high_MP = function( actor, battleState ) {				
	const node = new YesNoNode( actor, battleState );

	node.sleightOfHand = BattleCalc.getEquippedAbility( actor, 'sleight_of_hand' );

	node.branches[ node.NO ] = new TreeNode( null, null );
	
	if( node.sleightOfHand ) {
		node.branches[ node.YES ] = new UseAbility( actor, 'sleight_of_hand' );
	} else {
		node.branches[ node.YES ] = node.branches[ node.NO ];		
	}
	
	node.yesNoEvalFunction = function( target ) {
		return this.sleightOfHand && target.mp > this.sleightOfHand.potency*0.65;
	}		

	return node;	
}
module.exports = Q_high_MP
