const removeAllEventEmitters = (obj) => {
  if (typeof obj === 'object' && obj !== null) {
    const result_obj = {};
    for (const [key, val] of Object.entries(obj)) {
      if (typeof val?.emit !== 'function') {
        result_obj[key] = removeAllEventEmitters(val);
      }
    }
    return result_obj;
  } else if (Array.isArray(obj)) {
    for (const item of obj) {
      removeAllEventEmitters(item);
    }
    return obj;
  } else {
    return obj;
  }
};
module.exports = removeAllEventEmitters;
