const DoorsFactory = function(tiles, entrance, exits) {

  const doors = [];

  const makeDoor = (x, y, direction, isEntrance) => {
    return {
      door: true,
      x,
      y,
      direction,
      isEntrance,
    };
  };

  var tileA, tileB;
  var i, j, k;
  var candidates;
  var randomCandidate;

  var allSidesWithDoors = [entrance].concat(exits);
  for (k = 0; k < allSidesWithDoors.length; ++k) {
    candidates = [];

    switch (allSidesWithDoors[k]) {
      case 'NORTH':
        for (i = 0; i < tiles.length; ++i) {
          tileA = tiles[i];
          var tileNorthOfMe = false;
          for (j = 0; j < tiles.length; ++j) {
            tileB = tiles[j];
            if (tileB.y < tileA.y) {
              tileNorthOfMe = true;
              break;
            }
          }

          if (!tileNorthOfMe) {
            candidates.push(tileA);
          }
        }

        randomCandidate = candidates[ Math.floor(Math.random()*candidates.length) ];
        doors.push(makeDoor(randomCandidate.x-1+Math.round(Math.random())*2,randomCandidate.y-1,allSidesWithDoors[k],entrance==='NORTH'));
        break;

      case 'SOUTH':
        for (i = 0; i < tiles.length; ++i) {
          tileA = tiles[i];
          var tileSouthOfMe = false;
          for (j = 0; j < tiles.length; ++j) {
            tileB = tiles[j];
            if (tileB.y > tileA.y) {
              tileSouthOfMe = true;
              break;
            }
          }

          if (!tileSouthOfMe) {
            candidates.push(tileA);
          }
        }

        randomCandidate = candidates[ Math.floor(Math.random()*candidates.length) ];
        doors.push(makeDoor(randomCandidate.x-1+Math.round(Math.random())*2,randomCandidate.y+1,allSidesWithDoors[k],entrance==='SOUTH'));
        break;

      case 'EAST':
        for (i = 0; i < tiles.length; ++i) {
          tileA = tiles[i];
          var tileEastOfMe = false;
          for (j = 0; j < tiles.length; ++j) {
            tileB = tiles[j];
            if (tileB.x > tileA.x) {
              tileEastOfMe = true;
              break;
            }
          }

          if (!tileEastOfMe) {
            candidates.push(tileA);
          }
        }

        randomCandidate = candidates[ Math.floor(Math.random()*candidates.length) ];
        doors.push(makeDoor(randomCandidate.x+1,randomCandidate.y-1+Math.round(Math.random())*2,allSidesWithDoors[k],entrance==='EAST'));
        break;

      case 'WEST':
        for (i = 0; i < tiles.length; ++i) {
          tileA = tiles[i];
          var tileWestOfMe = false;
          for (j = 0; j < tiles.length; ++j) {
            tileB = tiles[j];
            if (tileB.x < tileA.x) {
              tileWestOfMe = true;
              break;
            }
          }

          if (!tileWestOfMe) {
            candidates.push(tileA);
          }
        }

        randomCandidate = candidates[ Math.floor(Math.random()*candidates.length) ];
        doors.push(makeDoor(randomCandidate.x-1,randomCandidate.y-1+Math.round(Math.random())*2,allSidesWithDoors[k],entrance==='WEST'));
        break;
    }
  }

  if (doors.length >= 3) {
    // remove some doors randomly
    for (var q = doors.length - 1; q >= 0; q -= 2) {
      if (!doors[q].isEntrance && Math.random() < 0.5) {
        doors.splice(q, 1);
      }
    }
  }

  return doors;
};
module.exports = DoorsFactory;
