const ItemGenerator = require('../../../game_items/ItemGenerator.js');
const Dagger = require('../../../game_items/equipment/weapon/Dagger.js');
const getMobEquipmenAssignmentFromBags = require('./getMobEquipmenAssignmentFromBags');

const snake = (level) => {
  const handle = 'snake';
  const AI_PRIORITIES = ['dps_close', 'tank', 'interference', 'support', 'dps_ranged'];
  const bags = [{
    items: [
      ItemGenerator.getRandomItem(Dagger, 0, Math.min(1,0.1+level/100)),
    ],
  }];

  return {
    handle,
    level,
    getAbilityTrees: ((bound_level) => ([{
      handle: 'snake_abilities',
      abilities: {
        move: { handle: 'move', level: 1 },
        melee_attack: { handle: 'melee_attack', level: 1 },
        poison_weapon: { handle: 'poison_weapon', level: Math.min(10,Math.round(1+bound_level/2)) },
        quickness: { handle: 'quickness', level: Math.min(10,Math.round(1+bound_level/2)) },
        preparation: { handle: 'preparation', level: Math.min(10,Math.round(1+bound_level/2)) },
        blurred_form: { handle: 'blurred_form', level: Math.min(10,Math.round(1+bound_level/2)) },
      },
    }])).bind(null, level),
    getBaseAttributes: ((bound_level) => ({
      learning: Math.round(3.0 + bound_level*0.6 + Math.random()*3),
      perception: Math.round(4.0 + bound_level*0.8 + Math.random()*3),
      mana: Math.round(2.5 + bound_level*0.45 + Math.random()*3),
      toughness: Math.round(2.5 + bound_level*0.5 + Math.random()*3),
      strength: Math.round(3.5 + bound_level*0.35 + Math.random()*3),
      willpower: Math.round(2.0 + bound_level*0.4 + Math.random()*3),
      dexterity: Math.round(5.0 + bound_level*0.8 + Math.random()*3),
    })).bind(null, level),
    getDefaultAIConfig: () => AI_PRIORITIES,
    xpValue: level * 1200,
    bags,
    build: {
      ai: {
        priorities: AI_PRIORITIES,
        settings: {
          chanceToSkipRoles: true,
          autoMove: true,
          waitForAPMP: false,
        },
      },
      ai_unit: true,
      beast: true,
      equipment_assignment: getMobEquipmenAssignmentFromBags(bags),
      equipped_abilities: ['move', 'melee_attack', 'poison_weapon'],
      handle,
      humanoid: false,
      level,
      team: 'black',
      undead: false,
      unit: true,
    },
  };
};
module.exports = snake;
