var ItemGenerator = require('../../../game_items/ItemGenerator.js');
var MedHelmet = require('../../../game_items/equipment/helmet/MedHelmet.js');
var MedTorsoe = require('../../../game_items/equipment/torsoe/MedTorsoe.js');
var MedBoots = require('../../../game_items/equipment/boots/MedBoots.js');
var Dagger = require('../../../game_items/equipment/weapon/Dagger.js');
var Bow = require('../../../game_items/equipment/off_hand/Bow.js');

module.exports = function() {
  return {
    handle: 'assassin',
    unit: true,
    attributes: {
      base: {
        learning: 50,
        perception: 50,
        mana: 50,
        toughness: 50,
        strength: 50,
        willpower: 50,
        dexterity: 50,
        regeneration: 0,
        speed: 0,
        magicalGravity: 0,
        meleeDamage: 0,
        armorClass: 0,
        dodgeChance: 0,
        physicalResil: 0,
        mentalResil: 0,
      },
      fromUpgrades: {
        learning: 0,
        perception: 0,
        mana: 0,
        toughness: 0,
        strength: 0,
        willpower: 0,
        dexterity: 0,
      },
    },
    abilityTrees: [{
      handle: 'skeleton_abilities',
      abilities: {
        move: { handle: 'move',                level: 1 },
        melee_attack: { handle: 'melee_attack',        level: 1 },
        ice_nine: { handle: 'ice_nine',            level: 10 },
        road_to_nowhere: { handle: 'road_to_nowhere',     level: 10 },
        arrow_shot: { handle: 'arrow_shot',       level: 10 },
        range: { handle: 'range',            level: 10 },
        razor_shot: { handle: 'razor_shot',            level: 10 },
        chain_pull: { handle: 'chain_pull',           level: 10 },
        angel_mask: { handle: 'angel_mask',     level: 10 },
        psyche_out: { handle: 'psyche_out',          level: 10 },
        multi_shot: { handle: 'multi_shot',       level: 10 },
      },
    }],
    equipped_abilities: ['move','melee_attack','ice_nine','road_to_nowhere','arrow_shot','range','razor_shot','chain_pull','angel_mask','psyche_out','multi_shot'],
    ai: {
      priorities: ['interference', 'dps_ranged', 'dps_close', 'tank', 'support'],
      settings: {
        chanceToSkipRoles: true,
        autoMove: true,
        waitForAPMP: false,
      },
    },
    equipment: {
      helmet: ItemGenerator.getRandomItem(MedHelmet, 1.0, 1.0),
      torsoe: ItemGenerator.getRandomItem(MedTorsoe, 1.0, 1.0),
      boots: ItemGenerator.getRandomItem(MedBoots, 1.0, 1.0),
      weapon: ItemGenerator.getRandomItem(Dagger, 1.0, 1.0),
      off_hand: ItemGenerator.getRandomItem(Bow, 1.0, 1.0),
    },
  };
};
