export interface HeroRosterDocument {
  _id: string;
  hero_roster: {
    [key: string]: RosterHero;
  };
}

export type HeroHandle = 
    'assassin'
  | 'battle_mage'
  | 'dreamsmith'
  | 'invoker'
  | 'knight'
  | 'mercenary'
  | 'monk'
  | 'paladin'
  | 'ranger'
  | 'shaman'
  | 'warlock'

export interface RosterHero {
  handle: string;
  level: number;
  xp: number;
}

export interface InnLogsDocument {
  _id: string;
  inn_logs: {
    [key: string]: InnLog;
  };
}

export interface InnLog {
  _id: string;
  game_submode: string;
  new_rank: number;
  new_tier: number;
  new_tourney_id: string;
  old_tier: number;
  old_tourney_id: string;
  playerId: string;
  rewards: {
    gold: number;
    items: {
      [key: string]: GameItem;
    };
    pixie_dust: number;
  };
  timestamp: number;
}

export interface PlayerInnStateDocument {
  _id: string;
  player_inn_state: {
    [key in GameSubmode]: PlayerInnState;
  };
}

export interface PlayerInnState {
  active_tourney_id: string;
  challenges_left: number;
  current_rank: number;
  current_tier: number;
  last_num_peanuts: number;
  last_rank_change_at: number;
  tourney_entered_at: number;
}

export interface InnTournamentDocument {
  _id: string;
  game_submode: GameSubmode;
  players: InnPlayer[];
  started_at: number;
  tier: number;
}

export interface InnPlayer { _id: string }

export type GameMode = 'GAME_MODE_caverns' | 'GAME_MODE_pvpAuto' | 'GAME_MODE_pvpLive';

export type GameSubmode =
    'GAME_SUBMODE_pvp1v1'
  | 'GAME_SUBMODE_pvp2v2'
  | 'GAME_SUBMODE_pvp3v3'
  | 'GAME_SUBMODE_pvp5v5'
  | 'GAME_SUBMODE_pvp7v7'
  | 'GAME_SUBMODE_pvp11v11'
  | 'GAME_SUBMODE_caverns1man'
  | 'GAME_SUBMODE_caverns2man'
  | 'GAME_SUBMODE_caverns3man'
  | 'GAME_SUBMODE_caverns5man'
  | 'GAME_SUBMODE_caverns7man'
  | 'GAME_SUBMODE_caverns11man'

export interface GameItem {
  _id: string;
}

export * from 'mongodb';
